#include <controllers/apiController.hh>

using std::to_string;

void apiController::getImg(const HttpRequestPtr& req, Callback&& callback) 
{
    auto param = req->getParameters();
    post p;
    string hash;
    if (param.find("q") != param.end()) {
        hash = param["q"];
        p = ih->getImgHash(hash);
    }
    else {
        p = ih->getImgRandom();
    }
    if (!p.data || p.id == -1 || p.hash.size() == 0 || p.likes == -1) {
        auto resp = HttpResponse::newNotFoundResponse();
        callback(resp);
        return;
    }
    auto resp = HttpResponse::newHttpResponse();
    resp->setContentTypeCode(CT_IMAGE_JPG);
    resp->setBody(*(p.data));
    resp->setStatusCode(k200OK);
    resp->addHeader("hash", p.hash);
    resp->addHeader("likes", to_string(p.likes));
    resp->addHeader("id", to_string(p.id));
    callback(resp);
    return;

}
