#include <controllers/apiController.hh>

using std::stoi;
using std::to_string;

void apiController::getImgFromId([[maybe_unused]]const HttpRequestPtr& req, 
        Callback&& callback, const string& sId)
{
    int id = stoi(sId);
    auto p = ih->getImgId(id);
    if (!p.data || p.id == -1 || p.hash.size() == 0 || p.likes == -1) {
        auto resp = HttpResponse::newNotFoundResponse();
        callback(resp);
        return;
    }
    auto resp = HttpResponse::newHttpResponse();
    resp->setContentTypeCode(CT_IMAGE_JPG);
    resp->setBody(string(*(p.data)));
    resp->setStatusCode(k200OK);
    resp->addHeader("hash", p.hash);
    resp->addHeader("likes", to_string(p.likes));
    callback(resp);
    return;


}
