#include <controllers/apiController.hh>

void apiController::getTop(const HttpRequestPtr& req, Callback&& callback)
{
    auto param = req->getParameters();
    if (param.find("q") == param.end()) {
        auto resp = HttpResponse::newNotFoundResponse();
        callback(resp);
        return;
    }
    auto page = stoi(param["q"]);
    auto j = ih->getTopPage(page);
    auto resp = HttpResponse::newHttpResponse();
    resp->setBody(j.dump(4));
    resp->setStatusCode(k200OK);
    resp->setContentTypeCode(CT_APPLICATION_JSON);
    callback(resp);
    return;
}
