#include <controllers/apiController.hh>

void apiController::getUploads(const HttpRequestPtr& req, Callback&& callback)
{
    auto ip = req->peerAddr().toIp();
    db->execSqlAsync(queryUserUploads,
        [callback](const Result& result) {
            json j;
            if (!result.empty()) {
                for (const auto& row : result) {
                    json post;
                    post["id"].push_back(row["post_id"].as<int>());
                    post["hash"].push_back(row["post_filename"].as<string>());
                    post["timestamp"].push_back(row["created_at"].as<string>());
                    j["posts"].push_back(post);
                }
            }
            auto resp = HttpResponse::newHttpResponse();
            resp->setBody(j.dump(4));
            resp->setStatusCode(k200OK);
            resp->setContentTypeCode(CT_APPLICATION_JSON);
            callback(resp);
            return;
        },
        [callback](const DrogonDbException& e) {
            auto resp = HttpResponse::newHttpResponse();
            resp->setStatusCode(k500InternalServerError);
            resp->setBody("err" + string(e.base().what()));
            callback(resp);
            return;
        },
        ip
    );
    // omit callback
}
