#include <local/imageHub/imageHub.hh>
#include <fstream>
#include <sstream>
#include <stdexcept>

using std::ifstream;
using std::ios;
using std::runtime_error;
using std::ostringstream;
using std::max;

imageHub::imageHub()
{
    imgPath = app().getCustomConfig()[imgDir].asString();
    DbClientPtr db = app().getDbClient(dbName);
    try {
        auto result = db->execSqlSync(queryInitLoad);
        for (const auto& row : result) {
            auto hash = row["post_filename"].as<string>();
            auto likes = row["like_count"].as<int>();
            auto id = row["post_id"].as<int>();
            imageId.push_back(id);
            idToHash[id] = hash;
            hashToId[hash] = id;
            idToLikes[id] = likes;
            currPostId = max(currPostId, id);
            string path = imgPath + '/' + hash + jpgExt;
            ifstream file(path, ios::binary);
            if (!file) {
                throw runtime_error("Error: Unable to open file " + path);
                app().quit();
            }
            ostringstream buffer;
            buffer << file.rdbuf();
            file.close();
            idToJpg[id] = buffer.str();
        }
    }
    catch(const drogon::orm::DrogonDbException &e) {
        LOG_INFO << "Failed to load db";
        app().quit();
    }
    app().getLoop()->runEvery(topRefreshSec, createTopLambda());
}

imageHub::~imageHub()
{

}
