#include <local/imageHub/imageHub.hh>

using std::min;

function<void()> imageHub::createTopLambda()
{
    return [this]() {
        unique_lock lock(imageHubMutex);
        vector<pair<int, int>> tempData;
        top100.clear();
        for (const auto&[key, value] : idToLikes) {
            tempData.push_back({key, value});
        }
        sort(tempData.begin(), tempData.end(), [](const auto& l, 
                const auto& r) {
            if (l.second == r.second) {
                return l.first > r.first;
            }
            return l.second > r.second;
        });
        int size = min(100, static_cast<int>(tempData.size()));
        for (int i = 0; i < size; i++) {
            top100.push_back({tempData[i].first, tempData[i].second});
        }
    };
}
