#include <local/imageHub/imageHub.hh>

uint32_t imageHub::deleteRemove(int id, string hash)
{
    unique_lock lock(imageHubMutex);
    uint32_t flags = 0;
    if (id == -1 && hashToId.find(hash) == hashToId.end()) {
        setFlag(flags, 31);
        return flags;
    }
    else {
        id = hashToId[hash];
    }
    if (static_cast<int>(hash.size()) == 0 && 
            idToHash.find(id) == idToHash.end()) {
        setFlag(flags, 31);
        return flags;
    }
    else {
        hash = idToHash[id];
    }
    if (auto it = idToHash.find(id); it != idToHash.end()) {
        idToHash.erase(it);
    }
    else {
        setFlag(flags, 0);
    }
    if (auto it = hashToId.find(hash); it != hashToId.end()) {
        hashToId.erase(it);
    }
    else {
        setFlag(flags, 1);
    }
    if (auto it = idToJpg.find(id); it != idToJpg.end()) {
        idToJpg.erase(it);
    }
    else {
        setFlag(flags, 2);
    }
    if (auto it = idToLikes.find(id); it != idToLikes.end()) {
        idToLikes.erase(it);
    }
    else {
        setFlag(flags, 3);
    }
    auto size = static_cast<int>(imageId.size());
    if (size <= 1) {
        imageId.clear();
    }
    else {
        auto begin = imageId.begin();
        auto end = imageId.end();
        auto toRemove = find(begin, end, id);
        if (toRemove != end) {
            auto dist = distance(begin, toRemove);
            imageId[dist] = *(end - 1);
            imageId.pop_back();
        }
        else {
            setFlag(flags, 4);
        }
    }
    return flags;
}
