#include <local/imageHub/imageHub.hh>
#include <random>

using std::random_device;
using std::mt19937;
using std::uniform_int_distribution;
using std::max;

post imageHub::getImgRandom()
{
    shared_lock lock(imageHubMutex);
    random_device rd;
    mt19937 gen(rd());
    auto size = static_cast<int>(imageId.size());
    if (size < 1) {
        return post(-1, "", -1, nullptr);
    }
    uniform_int_distribution<int> dist(0, max(size - 1, 0));
    auto indx = dist(gen);
    auto id = imageId[indx];
    if (idToHash.find(id) == idToHash.end()) {
        return post(-1, "", -1, nullptr);
    }
    auto hash = idToHash[id];
    if (idToLikes.find(id) == idToLikes.end()) {
        return post(-1, "", -1, nullptr);
    }
    auto likes = idToLikes[id];
    string* jpeg = &idToJpg[id];
    return post(id, hash, likes, jpeg);
}
