#include <local/imageHub/imageHub.hh>

using std::min;

json imageHub::getTopPage(const int& page)
{
    shared_lock lock(imageHubMutex);
    json j;
    if (page < 1 || page > 10) {
        return j;
    }
    auto start = (page - 1) * 10;
    auto end = start + 10;
    auto size = static_cast<int>(top100.size());
    for (int i = start; i < min(size, end); i++) {
        json img;
        pair<int, int>& curr = top100[i];
        img["id"] = curr.first;
        img["likes"] = curr.second;
        img["hash"] = idToHash[curr.first];
        j["img"].push_back(img);
    }
    return j;
}

